/*
 * aufgabe3.c
 *
 *  Created on: 17.11.2012
 *      Author: Johann
 */


#include <stdio.h>

double potenz_iter_slow(double, int);
double potenz_iter_fast(double, int);
double potenz_rek_slow(double, int);
double potenz_rek_fast(double, int);

int counter_fast_ = 0;
int counter_slow_ = 0;

int main(void)
{
	setvbuf(stdout, NULL, _IONBF, 0);    /*  Die Standard-Ausgabe wird nicht gepuffert   */
	int e;
	double b;

	printf("\nBasis    = ");
	scanf("%lf", &b);
	printf("\nExponent = ");
	scanf("%d", &e);


	printf("\n%lf hoch %d = %lf; langsame Iteration\n", b, e, potenz_iter_slow(b, e));
	printf("\n%lf hoch %d = %lf; schnelle Iteration\n", b, e, potenz_iter_fast(b, e));
	printf("\n%lf hoch %d = %lf; langsame Rekursion\n", b, e, potenz_rek_slow(b, e));
	printf("\n%lf hoch %d = %lf; schnelle Rekursion\n", b, e, potenz_rek_fast(b, e));

	printf("\nDie langsame Rekursion benoetigt %d Multiplikationen\n", counter_slow_);
	printf("\nDie schnelle Rekursion benoetigt %d Multiplikationen\n", counter_fast_);

	return 0;
}

/****** Funktionsdefinitionen ************/

/*  langsamer Algorithmus Iteration */

double potenz_iter_slow(double b, int e)
{
	int counter = 0;
	double p = b;

	if (e == 0)
		return 1.0;

	while (e > 1)
	{
		p *= b;
		counter++;
		e--;
	}

	printf("\nDie langsame Iteration benoetigt %d Multiplikationen\n", counter);
	return p;
}

/*schneller Algorithmus Iteration*/

double potenz_iter_fast(double b, int e)
{
	int counter = 0;
	double p = 1.0;

	while (e > 1)
	{
		if (e % 2)
		{
			p *= b;
			counter++;
		}
		e /= 2;
		b *= b;
		counter++;
	}

	printf("\nDie schnelle Iteration benoetigt %d Multiplikationen\n", ++counter);
	return b * p;
}

/*  langsamer Algorithmus Rekursion */

double potenz_rek_slow(double b, int e)
{
	if (e > 1)
	{
		counter_slow_++;
		return b * potenz_rek_slow(b, e - 1);
	}
	else if (e == 0)
		return 1.0;
	else
		return b;
}

/*schneller Algorithmus Rekursion*/

double potenz_rek_fast(double b, int e)
{
	double ph;
	if (e > 1)
	{
		ph = potenz_rek_fast(b, e / 2);
		ph *= ph;
		// Version mit Zwischenspeicherung:
		// ph = potenz_rek_fast(b, e / 2) * potenz_rek_fast(b, e / 2);
		counter_fast_++;
		if (e % 2)
		{
			counter_fast_++;
			return b * ph;
		}
		else
			return ph;
	}
	else if (e == 0)
		return 1.0;
	else
		return b;
}
/* Der langsame rekrursive Algorithmus benoetigt k Aufrufe.
   In der ersten Version des schnellen rekursiven Algorithmis wird in jedem Aufruf der Exponent halbiert,
   weshalb dieser nur log_2(e) Funktionsaufrufe benoetigt.
   In der zweiten Version des schnellen rekursiven Algorithmus wird zwar ebenfalls in jedem Aufruf der Exponent halbiert, aber die Funktion zweimal aufgerufen.
   Deshalb benoetigt man 2^0 + 2^1 + 2^2 +...+2^(k-1) = 2^k -1 = e-1 Aufrufe.
 */
